﻿using System;
using System.Text;
using System.IO;
using System.Net;
using System.Net.Sockets;
using System.Threading;

public class GetSocket
{

    // Fancypants socket routine
    private static Socket ConnectSocket(string server, int port)
    {
        Socket s = null;
        IPHostEntry hostEntry = null;

        // Get host related information.
        hostEntry = Dns.GetHostEntry(server);

        foreach (IPAddress address in hostEntry.AddressList)
        {
            IPEndPoint ipe = new IPEndPoint(address, port);
            Socket tempSocket =  new Socket(ipe.AddressFamily, SocketType.Stream, ProtocolType.Tcp);

            tempSocket.Connect(ipe);

            if (tempSocket.Connected)
            {
                s = tempSocket;
                break;
            }
            else
            {
                continue;
            }
        }
        return s;
    }

    private static string SocketSendReceive(string server, int port)
    {
        //Header
        //The Spinneret dispatch method will execute the correct method
        //Firmware in this case.  The extension could be anything -> ah restFULL
        string request = "PUT /firmware.htm HTTP/1.1\r\n";

        // Get the party started
        Byte[] bytesSent = Encoding.ASCII.GetBytes(request);
        Byte[] bytesReceived = new Byte[256];
        string responseText = string.Empty;

        // Fancypants socket guy.
        Socket socket = ConnectSocket(server, port);

        if (socket == null){
            return ("Connection failed");
        }

        // Send request to the server.
        socket.Send(bytesSent, bytesSent.Length, 0);
        responseText = GetResponseText(socket);
        Console.WriteLine(responseText);

        //Username
        Console.Write("Enter your id: ");
        string username = Console.ReadLine();
        bytesSent = Encoding.ASCII.GetBytes(username);
        socket.Send(bytesSent, bytesSent.Length, 0);

        responseText = GetResponseText(socket);
        Console.WriteLine(responseText);

        // BInary File
        Console.Write("Enter the file to upload: ");
        string path = Console.ReadLine();
        if (string.IsNullOrEmpty(path))
            //path = @"C:\image.bin";
            path = @"C:\led0.bin";

        string filename = Path.GetFileName(path);
        bytesSent = Encoding.ASCII.GetBytes(filename);
        socket.Send(bytesSent, bytesSent.Length, 0);

        responseText = GetResponseText(socket);
        Console.WriteLine(responseText);

        if (File.Exists(path))
        {
            // Open a binary reader
            BinaryReader binReader = new BinaryReader(File.Open(path, FileMode.Open));
            long bytesToRead = binReader.BaseStream.Length;
            binReader.BaseStream.Position = 0;
            
            // Get the byte count.
            // Set the byte count to 1460 if the file is larger and 1460 bytes
            byte[] data;
            int count = bytesToRead >= 1460 ? 1460 : (int)bytesToRead;
            int idx = 0;

            // Send the byte count
            bytesSent = Encoding.ASCII.GetBytes(bytesToRead.ToString());
            socket.Send(bytesSent, bytesSent.Length, 0);
            responseText = GetResponseText(socket);
            Console.WriteLine(responseText);
            responseText = string.Empty;

            try
            {   // Loop through the file 1460 bytes at a time
                // the last send will be less than 1460 bytes
                do
                {
                    data = new byte[count];
                    idx += count;

                    // Read and send
                    binReader.Read(data, 0, count);
                    socket.Send(data, data.Length, 0);
                    
                    // Get the response
                    responseText = GetResponseText(socket);
                    Console.WriteLine(responseText);
                    Console.WriteLine("Bytes sent: {0}", idx);

                    // Give the Spinneret a breath
                    Thread.Sleep(500);

                    // Are we at the end?
                    if (count > bytesToRead - idx)
                        count = Convert.ToInt32(bytesToRead - idx);

                }
                while (idx < bytesToRead);

            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.ToString());
            }
            finally
            {
                binReader.Close();
            }
        }


        return "Done!";
    }


    // Response helper
    public static string GetResponseText(Socket s)
    {
        int bytes = 0;
        string current = string.Empty;
        byte[] bytesReceived = new Byte[256];
        do
        {
            bytes = s.Receive(bytesReceived, bytesReceived.Length, 0);
            current = Encoding.ASCII.GetString(bytesReceived, 0, bytes);
        }
        while (current.Length == 0);

        return current;
    }

    // Main entry
    public static void Main(string[] args)
    {
        string host;
        int port = 5000;


        if (args.Length == 0)
        {
            host = "spinneret.servebeer.com";
            port = 5000;
        }
        else
        {
            host = args[0];
            int.TryParse(args[1], out port);

        }

        string result = SocketSendReceive(host, port);
        Console.WriteLine("\r\n{0}\r\n", result);
    }
}

